
# coding: utf-8

# In[12]:


import time
from pynq import Overlay
import pynq.lib.dma
from pynq import Xlnk
import numpy as np
from pynq import MMIO
import random


# In[13]:


import numpy as np


fecdat = data = np.load('fecdat_latclassify_raw.npz')
train_X = fecdat['train_X']
train_y = fecdat['train_y']
test_X = fecdat['test_X']
test_y =fecdat['test_y']

print(test_X.shape)
print(test_y.shape)


# In[14]:


from pynq import Overlay

overlay = Overlay('./fec_latclass_mlp2_axispynq.bit')
overlay.download()


# In[15]:


overlay.is_loaded()


# In[16]:


hier0 = overlay.streamFec


# In[6]:


get_ipython().magic('pinfo hier0')


# In[7]:


help(overlay)


# pred_ip = hier0.fecpredlite0_0
# help(pred_ip)

# In[17]:


idx=120
indat0= test_X[idx]
print(indat0.shape)


# In[18]:


dma_in = overlay.streamFec.fec_dma_in
dma_out = overlay.streamFec.fec_dma_out

#pred_ip = MMIO(0x43c00000, 0x10000) # we got this address from 
xlnk = Xlnk()


# In[19]:


indat0


# In[ ]:


#in_buffer = xlnk.cma_array(shape=(13,), dtype=np.uint32)
#out_buffer = xlnk.cma_array(shape=(13,), dtype=np.uint32)
in_buffer = xlnk.cma_array(shape=(13,), dtype=np.float32)
out_buffer = xlnk.cma_array(shape=(2,), dtype=np.float32)
#in_buffer = xlnk.cma_alloc(13, data_type = 'float')
#out_buffer = xlnk.cma_alloc(13, data_type = 'float')
#pred_ip.write(0x10, 1)

start = time.time()
#for i in range(13):
#    in_buffer[i] = np.uint32(indat0[i]*65536)
np.copyto(in_buffer, indat0)
print(in_buffer)
dma_in.sendchannel.transfer(in_buffer)
dma_in.sendchannel.wait()
print('input done')

dma_out.recvchannel.transfer(out_buffer)
dma_out.recvchannel.wait()
print('output got')

in_buffer.close()
out_buffer.close()

end = time.time()
print(end-start)

print(out_buffer)


# print(pred_ip.register_map.out_class)

# In[ ]:


print(out_buffer)


# In[ ]:


#pred_ip.write(0x00,0x01)

